#include "stdafx.h"
#include "MapiApp.h"
#include "EnumMessagesDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26455)
CEnumMessagesDlg::CEnumMessagesDlg(_In_opt_ CWnd* pParent) : CDialog{CEnumMessagesDlg::IDD, pParent},
                                                             m_pMAPISession{nullptr}
{
}

void CEnumMessagesDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_LST_MESSAGES, m_ctrlMessages);
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CEnumMessagesDlg, CDialog) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_DESTROY()
#pragma warning(suppress: 26454)
  ON_NOTIFY(NM_DBLCLK, IDC_LST_MESSAGES, &CEnumMessagesDlg::OnDblclkLstMessages)
END_MESSAGE_MAP()

BOOL CEnumMessagesDlg::OnInitDialog()
{
  //Validate our parameters
  ASSERT(m_pMAPISession != nullptr); //Member variable must have been setup

  //Let the base class do its thing
  __super::OnInitDialog();

  //Display a wait cursor while we enumerate the emails
  CWaitCursor wait;

  //Turn on full row select for the control
  m_ctrlMessages.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);

  //Setup the 3 columns in the list control
  CRect rCtrl;
  m_ctrlMessages.GetClientRect(rCtrl);
  const int nWidth = rCtrl.Width() / 3;
  m_ctrlMessages.InsertColumn(0, _T("From"), LVCFMT_LEFT, nWidth);
  m_ctrlMessages.InsertColumn(1, _T("Subject"), LVCFMT_LEFT, nWidth);
  m_ctrlMessages.InsertColumn(2, _T("Received"), LVCFMT_RIGHT, nWidth);

  //Read as many messages as we can
  m_Messages.clear();
  bool bMoreMessages{true};
  std::string sMessageId;
  std::string sSeedMessageID;
  int nIndex{0};
  while (bMoreMessages)
  {
#pragma warning(suppress: 26489)
    std::string sMessageID;
    bMoreMessages = m_pMAPISession->Find(sMessageID, sSeedMessageID);
    if (bMoreMessages)
    {
      CMapi::CMessage message;
#pragma warning(suppress: 26486)
      bMoreMessages = m_pMAPISession->Read(sMessageID, message);
      if (bMoreMessages)
      {
        LVITEM lvi{};
        lvi.mask = LVIF_TEXT;
        lvi.iItem = nIndex;
#pragma warning(suppress: 26486 26489)
        m_ctrlMessages.InsertItem(nIndex, CString(message.m_From.m_sAddress.c_str()));
        m_ctrlMessages.SetItemText(nIndex, 1, CString(message.m_sSubject.c_str()));
        m_ctrlMessages.SetItemText(nIndex, 2, CString(message.m_sDateReceived.c_str()));
        m_Messages.push_back(sMessageID);
        ++nIndex;
      }

      //Prepare for the next time around
      sSeedMessageID = sMessageID;
    }
  }

  return TRUE;
}

#pragma warning(suppress: 26429)
void CEnumMessagesDlg::OnDblclkLstMessages(NMHDR* pNMHDR, LRESULT* pResult)
{
  //Validate our parameters
#pragma warning(suppress: 26496)
  AFXASSUME(m_pMAPISession);

#pragma warning(suppress: 26462 26490)
  auto lpnmitem{reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR)};
#pragma warning(suppress: 26496)
  AFXASSUME(lpnmitem != nullptr);
  if (lpnmitem->iItem != -1)
  {
#pragma warning(suppress: 26446)
    const std::string& sMsgID{m_Messages[lpnmitem->iItem]};
    CMapi::CMessage message;
#pragma warning(suppress: 26486)
    if (m_pMAPISession->Read(sMsgID, message))
    {
      //For demonstration purposes, Just display the body of the message read
      CString sMsg;
      AfxFormatString1(sMsg, IDP_MESSAGE_BODY, CString(message.m_sBody.c_str()));
      AfxMessageBox(sMsg);
    }
    else
    {
      CString sError;
      sError.Format(_T("%u"), m_pMAPISession->GetLastError());

      CString sMsg;
      AfxFormatString1(sMsg, IDP_FAIL_READ_MESSAGE, sError);
      AfxMessageBox(sMsg);
    }
  }

  *pResult = 0;
}
